from arduino import Arduino
import time
import csv
from apm import *

import matplotlib.pyplot as plt
plt.ion()


b = Arduino('COM3')
write_pin = 3
read_pin = 'A0'


#Declare output pins as a list/tuple
b.output([])

#Setup output file
output_file = open('output.csv', 'wb')
file_writer = csv.writer(output_file)
'''
#Setup graph
x = []
yI = []
yS = []
plt.plot(x, yI)
plt.plot(x, yS)
plt.xlabel('Time')
plt.ylabel('Temperature')
plt.ylim(60,150)
'''

#Initialize
startTime = time.time()
lastTime = int(round(time.time() * 1000))
lastErr = 0
errSum = 0
out_min = 0
out_max = 255
out = 0

cycle_time = 2

################################
#######  APM  ##################
################################



################################
################################
################################

print "Initializing..."

#Run Program
try:
    while (True):
        
        #Read
        time.sleep(1)
        print "---------------"
        print "INPUT"
        raw_input = b.analogRead(read_pin)
        print raw_input
        if(raw_input != "w"):
            val = int(raw_input)
            print val
            voltage = val*(3300/1024)
            print "voltage: %s" % voltage
            DegC = (voltage - 500)/10
            DegF = DegC*1.8+32
            read_out = 'DegC: ' + str(DegC) + ' DegF: ' + str(DegF)
            print read_out
        else:
            print "ERROR"

        ###########################################
        #### CONSTRUCT CONTROLLER HERE ############
        ###########################################
        '''
        Available Variables
        Control:
            setpoint
            kp
            ki
            kd
        Input:
            voltage
        Output:
            out
        '''

        


        ###########################################
        #######   END CONTROLLER  #################
        ###########################################

        #Limit output to 255 mV
        if out > out_max:
            out = out_max
        if out < out_min:
            out = out_min
        print 'Out Limited: %s' % out
 

        #Write
        print "Writing to file:"
        print "Write pin: %s" % write_pin
        print "Out: %s" % out
        b.analogWrite(write_pin, out)
        print "Wrote to file:"
        print ''

        
        '''
        #Update Graph
        x.append(elapsed_time)
        yI.append(DegF)
        yS.append(setpoint)
        plt.plot(x, yI, color='r')
        plt.plot(x, yS, color='b')
        plt.ylim(60,150)
        plt.draw()
        '''
        '''
        #Digital Write
        b.setHigh(write_pin)
        time.sleep(.1)
        print b.getState(write_pin)
        b.setLow(write_pin)
        print "Blink"
        time.sleep(.1)
        '''

#End Program with Ctrl C
except KeyboardInterrupt:
    print "\nExiting..."
    b.analogWrite(write_pin, 0)
    #plt.show()
    b.close()
    output_file.close()

